{% extends 'base.html' %}

{% block title %}
asdasd
{% endblock %}

{% block content %}


<div class="row text-center">
    <div class="col">
        <h1>Welcome TweetMe2</h1>
    </div>
</div>

<div class="row mb-3">
    <div class="col-md-4 mx-auto col-10">
        <form class="form" id="tweet-create-form" method="post" action="/tweet-create">
            {% csrf_token %}
            <div class="d-none alert alert-danger" id="tweet-create-form-error"></div>
            <input type="hidden" value="/" name="next" />
            <textarea required="required" class="form-control" name="content" placeholder="Your TWEET..."></textarea>
            <button type="submit" class="btn btn-primary">Tweet</button>
        </form>
    </div>
</div>

<div class="row" id="tweets">
    replace me
</div>

<script>

    function handleTweetFormError(msg, display){
        let myErrorDiv = document.getElementById("tweet-create-form-error")
        if (display === true){
            // show error
            myErrorDiv.setAttribute("class", 'd-block alert alert-danger')
            myErrorDiv.innerText = msg
        } else {
            // hide error
            myErrorDiv.setAttribute("class", 'd-none alert alert-danger')
        }
    }


    function handleTweetCreateFormDidSubmit(event){
        event.preventDefault()
        const myForm = event.target
        const myFormData = new FormData(myForm)
        const url = myForm.getAttribute('action')
        const method = myForm.getAttribute('method')

        const xhr = new XMLHttpRequest()
        xhr.responseType = 'json'
        xhr.open(method, url)
        xhr.setRequestHeader("HTTP_X_REQUESTED_WITH", "XMLHttpRequest")
        xhr.setRequestHeader("X-Requested-with", "XMLHttpRequest")
        xhr.onload = function() {
            if (xhr.status === 201){
                const newTweet = xhr.response
                const newTweetElement = formatTweetElement(newTweet)
                const ogHtml = tweetsContainerElement.innerHTML
                tweetsContainerElement.innerHTML = newTweetElement + ogHtml
                myForm.reset()
            } else if (xhr.status === 400) {
                const errorJson = xhr.response
                const contentError = errorJson.content
                let contentErrorMsg;
                if (contentError) {
                    contentErrorMsg = contentError[0]
                    if (contentErrorMsg) {
                        handleTweetFormError(contentErrorMsg, true)
                    } else {
                        alert("An error occurred. Please try again.")
                    }
                } else {
                    alert("An error occurred. Please try again.")
                }
                console.log(contentErrorMsg)
            } else if (xhr.status === 500) {
                alert("There was a server error, please try again.")
            } else if (xhr.status === 401) {
                alert("You must be logged in!")
                window.location.href = '/login'
            } else if (xhr.status === 403) {
                alert("You must be logged in!")
                window.location.href = '/login'
            }
        }
        xhr.onerror = function() {
            alert('An error occurred. Please try again later.')
        }
        xhr.send(myFormData)
    }

    const tweetCreateFormEl = document.getElementById('tweet-create-form')

    tweetCreateFormEl.addEventListener("submit", handleTweetCreateFormDidSubmit)

    const tweetsContainerElement = document.getElementById('tweets')

    function loadTweets(tweetsElement) {
        const xhr = new XMLHttpRequest()
        const method = 'GET'
        const url = '/tweets'
        const responseType = 'json'

        xhr.responseType = responseType
        xhr.open(method, url)
        xhr.onload = function(){
            const serverResponse = xhr.response
            const listedItems = serverResponse
            let finalTweetStr = ""
            let i;
            for(i=0;i<listedItems.length;i++){
                finalTweetStr += formatTweetElement(listedItems[i])
            }
                tweetsElement.innerHTML = finalTweetStr
            }
        xhr.send()
    }

    loadTweets(tweetsContainerElement)

function getCookie(name) {
    let cookieValue = null;
    if (document.cookie && document.cookie !== '') {
        const cookies = document.cookie.split(';');
        for (let i = 0; i < cookies.length; i++) {
            const cookie = cookies[i].trim();
            // Does this cookie string begin with the name we want?
            if (cookie.substring(0, name.length + 1) === (name + '=')) {
                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                break;
            }
        }
    }
    return cookieValue;
}


    function handleTweetActionBtn(tweet_id, currentCount, action){
        console.log(tweet_id + ' ' + currentCount)
        const csrftoken = getCookie('csrftoken');
        const url = '/api/tweets/action'
        const method = "POST"
        const data = JSON.stringify({
            id: tweet_id,
            action: action
        })
        const xhr = new XMLHttpRequest()
        xhr.open(method, url)
        xhr.setRequestHeader("Content-Type", "application/json")
        xhr.setRequestHeader("HTTP_X_REQUESTED_WITH", "XMLHttpRequest")
        xhr.setRequestHeader("X-Requested-with", "XMLHttpRequest")
        xhr.setRequestHeader("X-CSRFToken", csrftoken)
        xhr.onload = function() {
            // with react this handle state mush better
            loadTweets(tweetsContainerElement)
        }
        xhr.send(data)


    }

    function ReTweetBtn(tweet){
        return "<button class='btn btn-outline-success' onclick=handleTweetActionBtn(" + tweet.id +"," + tweet.likes+",'retweet')>retweet</button>"
    }

    function UnLikeBtn(tweet){
        return "<button class='btn btn-outline-primary' onclick=handleTweetActionBtn(" + tweet.id +"," + tweet.likes+",'unlike')>unlike</button>"
    }

    function LikeBtn(tweet){
        return "<button class='btn btn-primary' onclick=handleTweetActionBtn(" + tweet.id +"," + tweet.likes+",'like'"+")>Likes "+tweet.likes+"</button>"
    }

    function formatTweetElement(tweet){
        let formattedTweet = "<div class='col-12 com-md-10 mx-auto border rounded py-2 mb-4 tweet ' id='tweet-" + tweet.id +"'><p>"+ tweet.content +
            "</p><div class='btn-group'>" +
             LikeBtn(tweet)+
             UnLikeBtn(tweet) +
             ReTweetBtn(tweet) +
            "</div></div>"
        return formattedTweet
    }

</script>
{% endblock %}
